Add Ganeti 2.9 design document
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # Note: these are automake-specific variables, and must be named after
44 # the directory + 'dir' suffix
45 clientdir = $(pkgpythondir)/client
46 cmdlibdir = $(pkgpythondir)/cmdlib
47 hypervisordir = $(pkgpythondir)/hypervisor
48 storagedir = $(pkgpythondir)/storage
49 httpdir = $(pkgpythondir)/http
50 masterddir = $(pkgpythondir)/masterd
51 confddir = $(pkgpythondir)/confd
52 rapidir = $(pkgpythondir)/rapi
53 serverdir = $(pkgpythondir)/server
54 watcherdir = $(pkgpythondir)/watcher
55 impexpddir = $(pkgpythondir)/impexpd
56 utilsdir = $(pkgpythondir)/utils
57 toolsdir = $(pkglibdir)/tools
58 iallocatorsdir = $(pkglibdir)/iallocators
59 pytoolsdir = $(pkgpythondir)/tools
60 docdir = $(datadir)/doc/$(PACKAGE)
61 myexeclibdir = $(pkglibdir)
62
63 # Delete output file if an error occurred while building it
64 .DELETE_ON_ERROR:
65
66 HS_DIRS = \
67         src \
68         src/Ganeti \
69         src/Ganeti/Confd \
70         src/Ganeti/Curl \
71         src/Ganeti/DataCollectors \
72         src/Ganeti/HTools \
73         src/Ganeti/HTools/Backend \
74         src/Ganeti/HTools/Program \
75         src/Ganeti/Hypervisor \
76         src/Ganeti/Hypervisor/Xen \
77         src/Ganeti/Monitoring \
78         src/Ganeti/Query \
79         src/Ganeti/Storage \
80         src/Ganeti/Storage/Diskstats \
81         src/Ganeti/Storage/Drbd \
82         src/Ganeti/Storage/Lvm \
83         test/hs \
84         test/hs/Test \
85         test/hs/Test/Ganeti \
86         test/hs/Test/Ganeti/Storage \
87         test/hs/Test/Ganeti/Storage/Diskstats \
88         test/hs/Test/Ganeti/Storage/Drbd \
89         test/hs/Test/Ganeti/Storage/Lvm \
90         test/hs/Test/Ganeti/Confd \
91         test/hs/Test/Ganeti/HTools \
92         test/hs/Test/Ganeti/HTools/Backend \
93         test/hs/Test/Ganeti/Hypervisor \
94         test/hs/Test/Ganeti/Hypervisor/Xen \
95         test/hs/Test/Ganeti/Query
96
97 # Haskell directories without the roots (src, test/hs)
98 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
99
100 DIRS = \
101         $(HS_DIRS) \
102         autotools \
103         daemons \
104         devel \
105         devel/data \
106         doc \
107         doc/css \
108         doc/examples \
109         doc/examples/gnt-debug \
110         doc/examples/hooks \
111         test/data/htools \
112         test/data/htools/rapi \
113         test/hs/shelltests \
114         test/autotools \
115         lib \
116         lib/build \
117         lib/client \
118         lib/cmdlib \
119         lib/confd \
120         lib/http \
121         lib/hypervisor \
122         lib/impexpd \
123         lib/masterd \
124         lib/rapi \
125         lib/server \
126         lib/storage \
127         lib/tools \
128         lib/utils \
129         lib/watcher \
130         man \
131         qa \
132         test \
133         test/data \
134         test/data/bdev-rbd \
135         test/data/ovfdata \
136         test/data/ovfdata/other \
137         test/py \
138         tools
139
140 ALL_APIDOC_HS_DIRS = \
141         $(APIDOC_HS_DIR) \
142         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
143
144 BUILDTIME_DIR_AUTOCREATE = \
145         scripts \
146         $(APIDOC_DIR) \
147         $(ALL_APIDOC_HS_DIRS) \
148         $(APIDOC_PY_DIR) \
149         $(COVERAGE_DIR) \
150         $(COVERAGE_HS_DIR) \
151         $(COVERAGE_PY_DIR) \
152         .hpc
153
154 BUILDTIME_DIRS = \
155         $(BUILDTIME_DIR_AUTOCREATE) \
156         doc/html \
157         doc/man-html
158
159 DIRCHECK_EXCLUDE = \
160         $(BUILDTIME_DIRS) \
161         ganeti-[0-9]*.[0-9]*.[0-9]* \
162         doc/html/_* \
163         doc/man-html/_* \
164         autom4te.cache
165
166 # some helper vars
167 COVERAGE_DIR = doc/coverage
168 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
169 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
170 APIDOC_DIR = doc/api
171 APIDOC_PY_DIR = $(APIDOC_DIR)/py
172 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
173
174 MAINTAINERCLEANFILES = \
175         $(maninput) \
176         doc/install-quick.rst \
177         doc/news.rst \
178         doc/upgrade.rst \
179         vcs-version
180
181 maintainer-clean-local:
182         rm -rf $(BUILDTIME_DIRS)
183
184 CLEANFILES = \
185         $(addsuffix /*.py[co],$(DIRS)) \
186         $(addsuffix /*.hi,$(HS_DIRS)) \
187         $(addsuffix /*.o,$(HS_DIRS)) \
188         $(PYTHON_BOOTSTRAP) \
189         epydoc.conf \
190         $(REPLACE_VARS_SED) \
191         $(SHELL_ENV_INIT) \
192         daemons/daemon-util \
193         daemons/ganeti-cleaner \
194         devel/squeeze-amd64.tar.gz \
195         devel/squeeze-amd64.conf \
196         $(mandocrst) \
197         doc/manpages-enabled.rst \
198         $(BUILT_EXAMPLES) \
199         doc/examples/bash_completion \
200         doc/examples/bash_completion-debug \
201         lib/_generated_rpc.py \
202         $(man_MANS) \
203         $(manhtml) \
204         tools/kvm-ifup \
205         tools/vif-ganeti \
206         tools/net-common \
207         tools/users-setup \
208         tools/vcluster-setup \
209         stamp-directories \
210         stamp-srclinks \
211         $(nodist_pkgpython_PYTHON) \
212         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
213         $(HS_BUILT_TEST_HELPERS) \
214         src/ganeti-confd \
215         src/ganeti-luxid \
216         src/ganeti-mond \
217         .hpc/*.mix src/*.tix test/hs/*.tix \
218         doc/hs-lint.html
219
220 GENERATED_FILES = \
221         $(built_base_sources) \
222         $(BUILT_PYTHON_SOURCES) \
223         $(PYTHON_BOOTSTRAP)
224
225 HS_GENERATED_FILES =
226 if WANT_HTOOLS
227 HS_GENERATED_FILES += $(HS_PROGS)
228 if ENABLE_CONFD
229 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
230 endif
231
232 if ENABLE_MOND
233 HS_GENERATED_FILES += src/ganeti-mond
234 endif
235 endif
236
237 built_base_sources = \
238         stamp-directories \
239         stamp-srclinks
240
241 built_python_base_sources = \
242         lib/_autoconf.py \
243         lib/_vcsversion.py
244
245 BUILT_PYTHON_SOURCES = \
246         $(built_python_base_sources) \
247         lib/_generated_rpc.py
248
249 # Generating the RPC wrappers depends on many things, so make sure
250 # it's built at the end of the built sources
251 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
252
253 # these are all built from the underlying %.in sources
254 BUILT_EXAMPLES = \
255         doc/examples/ganeti-kvm-poweroff.initd \
256         doc/examples/ganeti.cron \
257         doc/examples/ganeti.initd \
258         doc/examples/ganeti.logrotate \
259         doc/examples/ganeti-master-role.ocf \
260         doc/examples/ganeti-node-role.ocf \
261         doc/examples/gnt-config-backup \
262         doc/examples/hooks/ipsec
263
264 nodist_pkgpython_PYTHON = \
265         $(BUILT_PYTHON_SOURCES)
266
267 noinst_PYTHON = \
268         lib/build/__init__.py \
269         lib/build/shell_example_lexer.py \
270         lib/build/sphinx_ext.py
271
272 pkgpython_PYTHON = \
273         lib/__init__.py \
274         lib/asyncnotifier.py \
275         lib/backend.py \
276         lib/bootstrap.py \
277         lib/cli.py \
278         lib/compat.py \
279         lib/config.py \
280         lib/constants.py \
281         lib/daemon.py \
282         lib/errors.py \
283         lib/hooksmaster.py \
284         lib/ht.py \
285         lib/jqueue.py \
286         lib/jstore.py \
287         lib/locking.py \
288         lib/luxi.py \
289         lib/mcpu.py \
290         lib/netutils.py \
291         lib/objects.py \
292         lib/opcodes.py \
293         lib/outils.py \
294         lib/ovf.py \
295         lib/pathutils.py \
296         lib/qlang.py \
297         lib/query.py \
298         lib/rpc.py \
299         lib/rpc_defs.py \
300         lib/runtime.py \
301         lib/serializer.py \
302         lib/ssconf.py \
303         lib/ssh.py \
304         lib/uidpool.py \
305         lib/vcluster.py \
306         lib/network.py \
307         lib/workerpool.py
308
309 client_PYTHON = \
310         lib/client/__init__.py \
311         lib/client/gnt_backup.py \
312         lib/client/gnt_cluster.py \
313         lib/client/gnt_debug.py \
314         lib/client/gnt_group.py \
315         lib/client/gnt_instance.py \
316         lib/client/gnt_job.py \
317         lib/client/gnt_node.py \
318         lib/client/gnt_network.py \
319         lib/client/gnt_os.py \
320         lib/client/gnt_storage.py
321
322 cmdlib_PYTHON = \
323         lib/cmdlib/__init__.py \
324         lib/cmdlib/backup.py \
325         lib/cmdlib/base.py \
326         lib/cmdlib/cluster.py \
327         lib/cmdlib/common.py \
328         lib/cmdlib/group.py \
329         lib/cmdlib/instance.py \
330         lib/cmdlib/instance_migration.py \
331         lib/cmdlib/instance_operation.py \
332         lib/cmdlib/instance_query.py \
333         lib/cmdlib/instance_storage.py \
334         lib/cmdlib/instance_utils.py \
335         lib/cmdlib/misc.py \
336         lib/cmdlib/network.py \
337         lib/cmdlib/node.py \
338         lib/cmdlib/operating_system.py \
339         lib/cmdlib/query.py \
340         lib/cmdlib/tags.py \
341         lib/cmdlib/test.py
342
343 hypervisor_PYTHON = \
344         lib/hypervisor/__init__.py \
345         lib/hypervisor/hv_base.py \
346         lib/hypervisor/hv_chroot.py \
347         lib/hypervisor/hv_fake.py \
348         lib/hypervisor/hv_kvm.py \
349         lib/hypervisor/hv_lxc.py \
350         lib/hypervisor/hv_xen.py
351
352 storage_PYTHON = \
353         lib/storage/__init__.py \
354         lib/storage/bdev.py \
355         lib/storage/base.py \
356         lib/storage/container.py \
357         lib/storage/drbd.py \
358         lib/storage/drbd_info.py \
359         lib/storage/drbd_cmdgen.py \
360         lib/storage/filestorage.py
361
362 rapi_PYTHON = \
363         lib/rapi/__init__.py \
364         lib/rapi/baserlib.py \
365         lib/rapi/client.py \
366         lib/rapi/client_utils.py \
367         lib/rapi/connector.py \
368         lib/rapi/rlib2.py \
369         lib/rapi/testutils.py
370
371 http_PYTHON = \
372         lib/http/__init__.py \
373         lib/http/auth.py \
374         lib/http/client.py \
375         lib/http/server.py
376
377 confd_PYTHON = \
378         lib/confd/__init__.py \
379         lib/confd/client.py
380
381 masterd_PYTHON = \
382         lib/masterd/__init__.py \
383         lib/masterd/iallocator.py \
384         lib/masterd/instance.py
385
386 impexpd_PYTHON = \
387         lib/impexpd/__init__.py
388
389 watcher_PYTHON = \
390         lib/watcher/__init__.py \
391         lib/watcher/nodemaint.py \
392         lib/watcher/state.py
393
394 server_PYTHON = \
395         lib/server/__init__.py \
396         lib/server/masterd.py \
397         lib/server/noded.py \
398         lib/server/rapi.py
399
400 pytools_PYTHON = \
401         lib/tools/__init__.py \
402         lib/tools/burnin.py \
403         lib/tools/ensure_dirs.py \
404         lib/tools/node_cleanup.py \
405         lib/tools/node_daemon_setup.py \
406         lib/tools/prepare_node_join.py
407
408 utils_PYTHON = \
409         lib/utils/__init__.py \
410         lib/utils/algo.py \
411         lib/utils/filelock.py \
412         lib/utils/hash.py \
413         lib/utils/io.py \
414         lib/utils/log.py \
415         lib/utils/lvm.py \
416         lib/utils/mlock.py \
417         lib/utils/nodesetup.py \
418         lib/utils/process.py \
419         lib/utils/retry.py \
420         lib/utils/storage.py \
421         lib/utils/text.py \
422         lib/utils/wrapper.py \
423         lib/utils/x509.py
424
425 docinput = \
426         doc/conf.py \
427         doc/css/style.css \
428         doc/admin.rst \
429         doc/cluster-merge.rst \
430         doc/design-2.0.rst \
431         doc/design-2.1.rst \
432         doc/design-2.2.rst \
433         doc/design-2.3.rst \
434         doc/design-2.4.rst \
435         doc/design-2.5.rst \
436         doc/design-2.6.rst \
437         doc/design-2.7.rst \
438         doc/design-2.8.rst \
439         doc/design-autorepair.rst \
440         doc/design-bulk-create.rst \
441         doc/design-chained-jobs.rst \
442         doc/design-cpu-pinning.rst \
443         doc/design-device-uuid-name.rst \
444         doc/design-draft.rst \
445         doc/design-htools-2.3.rst \
446         doc/design-http-server.rst \
447         doc/design-impexp2.rst \
448         doc/design-internal-shutdown.rst \
449         doc/design-lu-generated-jobs.rst \
450         doc/design-linuxha.rst \
451         doc/design-multi-reloc.rst \
452         doc/design-network.rst \
453         doc/design-node-add.rst \
454         doc/design-oob.rst \
455         doc/design-ovf-support.rst \
456         doc/design-opportunistic-locking.rst \
457         doc/design-partitioned.rst \
458         doc/design-query-splitting.rst \
459         doc/design-query2.rst \
460         doc/design-reason-trail.rst \
461         doc/design-resource-model.rst \
462         doc/design-restricted-commands.rst \
463         doc/design-shared-storage.rst \
464         doc/design-monitoring-agent.rst \
465         doc/design-virtual-clusters.rst \
466         doc/design-x509-ca.rst \
467         doc/design-hroller.rst \
468         doc/design-storagetypes.rst \
469         doc/devnotes.rst \
470         doc/glossary.rst \
471         doc/hooks.rst \
472         doc/iallocator.rst \
473         doc/index.rst \
474         doc/install-quick.rst \
475         doc/install.rst \
476         doc/locking.rst \
477         doc/manpages-disabled.rst \
478         doc/move-instance.rst \
479         doc/news.rst \
480         doc/ovfconverter.rst \
481         doc/rapi.rst \
482         doc/security.rst \
483         doc/upgrade.rst \
484         doc/virtual-cluster.rst \
485         doc/walkthrough.rst
486
487 # Generates file names such as "doc/man-gnt-instance.rst"
488 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
489
490 # Haskell programs to be installed in $PREFIX/bin
491 HS_BIN_PROGS=src/htools
492
493 # Haskell programs to be installed in the MYEXECLIB dir
494 if ENABLE_MOND
495 HS_MYEXECLIB_PROGS=src/mon-collector
496 else
497 HS_MYEXECLIB_PROGS=
498 endif
499
500 # Haskell programs to be compiled by "make really-all"
501 HS_COMPILE_PROGS= \
502         src/ganeti-mond \
503         src/hconfd \
504         src/hluxid \
505         src/rpc-test
506
507 # All Haskell non-test programs to be compiled but not automatically installed
508 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
509
510 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
511 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
512
513 HS_ALL_PROGS = \
514         $(HS_PROGS) \
515         test/hs/hpc-htools \
516         test/hs/hpc-mon-collector \
517         test/hs/htest \
518         $(HS_COMPILE_PROGS)
519
520 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
521 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
522
523 HFLAGS = \
524         -O -Wall -Werror -isrc \
525         -fwarn-monomorphism-restriction \
526         -fwarn-tabs \
527         $(GHC_BYVERSION_FLAGS)
528
529 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
530 HEXTRA =
531 # internal extra flags (used for test/hs/htest mainly)
532 HEXTRA_INT =
533 # exclude options for coverage reports
534 HPCEXCL = --exclude Main \
535         --exclude Ganeti.Constants \
536         --exclude Ganeti.HTools.QC \
537         --exclude Ganeti.THH \
538         --exclude Ganeti.Version \
539         --exclude Test.Ganeti.Attoparsec \
540         --exclude Test.Ganeti.TestCommon \
541         --exclude Test.Ganeti.TestHTools \
542         --exclude Test.Ganeti.TestHelper \
543         --exclude Test.Ganeti.TestImports \
544         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
545
546 HS_LIB_SRCS = \
547         src/Ganeti/BasicTypes.hs \
548         src/Ganeti/Common.hs \
549         src/Ganeti/Compat.hs \
550         src/Ganeti/Confd/Client.hs \
551         src/Ganeti/Confd/ClientFunctions.hs \
552         src/Ganeti/Confd/Server.hs \
553         src/Ganeti/Confd/Types.hs \
554         src/Ganeti/Confd/Utils.hs \
555         src/Ganeti/Config.hs \
556         src/Ganeti/ConfigReader.hs \
557         src/Ganeti/Curl/Multi.hs \
558         src/Ganeti/Daemon.hs \
559         src/Ganeti/DataCollectors/CLI.hs \
560         src/Ganeti/DataCollectors/Diskstats.hs \
561         src/Ganeti/DataCollectors/Drbd.hs \
562         src/Ganeti/DataCollectors/InstStatus.hs \
563         src/Ganeti/DataCollectors/InstStatusTypes.hs \
564         src/Ganeti/DataCollectors/Lv.hs \
565         src/Ganeti/DataCollectors/Program.hs \
566         src/Ganeti/DataCollectors/Types.hs \
567         src/Ganeti/Errors.hs \
568         src/Ganeti/HTools/Backend/IAlloc.hs \
569         src/Ganeti/HTools/Backend/Luxi.hs \
570         src/Ganeti/HTools/Backend/Rapi.hs \
571         src/Ganeti/HTools/Backend/Simu.hs \
572         src/Ganeti/HTools/Backend/Text.hs \
573         src/Ganeti/HTools/CLI.hs \
574         src/Ganeti/HTools/Cluster.hs \
575         src/Ganeti/HTools/Container.hs \
576         src/Ganeti/HTools/ExtLoader.hs \
577         src/Ganeti/HTools/Graph.hs \
578         src/Ganeti/HTools/Group.hs \
579         src/Ganeti/HTools/Instance.hs \
580         src/Ganeti/HTools/Loader.hs \
581         src/Ganeti/HTools/Nic.hs \
582         src/Ganeti/HTools/Node.hs \
583         src/Ganeti/HTools/PeerMap.hs \
584         src/Ganeti/HTools/Program/Hail.hs \
585         src/Ganeti/HTools/Program/Harep.hs \
586         src/Ganeti/HTools/Program/Hbal.hs \
587         src/Ganeti/HTools/Program/Hcheck.hs \
588         src/Ganeti/HTools/Program/Hinfo.hs \
589         src/Ganeti/HTools/Program/Hscan.hs \
590         src/Ganeti/HTools/Program/Hspace.hs \
591         src/Ganeti/HTools/Program/Hroller.hs \
592         src/Ganeti/HTools/Program/Main.hs \
593         src/Ganeti/HTools/Types.hs \
594         src/Ganeti/Hypervisor/Xen.hs \
595         src/Ganeti/Hypervisor/Xen/XmParser.hs \
596         src/Ganeti/Hypervisor/Xen/Types.hs \
597         src/Ganeti/Hash.hs \
598         src/Ganeti/JQueue.hs \
599         src/Ganeti/JSON.hs \
600         src/Ganeti/Jobs.hs \
601         src/Ganeti/Logging.hs \
602         src/Ganeti/Luxi.hs \
603         src/Ganeti/Monitoring/Server.hs \
604         src/Ganeti/Network.hs \
605         src/Ganeti/Objects.hs \
606         src/Ganeti/OpCodes.hs \
607         src/Ganeti/OpParams.hs \
608         src/Ganeti/Path.hs \
609         src/Ganeti/Query/Cluster.hs \
610         src/Ganeti/Query/Common.hs \
611         src/Ganeti/Query/Export.hs \
612         src/Ganeti/Query/Filter.hs \
613         src/Ganeti/Query/Group.hs \
614         src/Ganeti/Query/Job.hs \
615         src/Ganeti/Query/Language.hs \
616         src/Ganeti/Query/Network.hs \
617         src/Ganeti/Query/Node.hs \
618         src/Ganeti/Query/Query.hs \
619         src/Ganeti/Query/Server.hs \
620         src/Ganeti/Query/Types.hs \
621         src/Ganeti/Rpc.hs \
622         src/Ganeti/Runtime.hs \
623         src/Ganeti/Ssconf.hs \
624         src/Ganeti/Storage/Diskstats/Parser.hs \
625         src/Ganeti/Storage/Diskstats/Types.hs \
626         src/Ganeti/Storage/Drbd/Parser.hs \
627         src/Ganeti/Storage/Drbd/Types.hs \
628         src/Ganeti/Storage/Lvm/LVParser.hs \
629         src/Ganeti/Storage/Lvm/Types.hs \
630         src/Ganeti/Storage/Utils.hs \
631         src/Ganeti/THH.hs \
632         src/Ganeti/Types.hs \
633         src/Ganeti/Utils.hs
634
635 HS_TEST_SRCS = \
636         test/hs/Test/Ganeti/Attoparsec.hs \
637         test/hs/Test/Ganeti/BasicTypes.hs \
638         test/hs/Test/Ganeti/Common.hs \
639         test/hs/Test/Ganeti/Confd/Types.hs \
640         test/hs/Test/Ganeti/Confd/Utils.hs \
641         test/hs/Test/Ganeti/Daemon.hs \
642         test/hs/Test/Ganeti/Errors.hs \
643         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
644         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
645         test/hs/Test/Ganeti/HTools/CLI.hs \
646         test/hs/Test/Ganeti/HTools/Cluster.hs \
647         test/hs/Test/Ganeti/HTools/Container.hs \
648         test/hs/Test/Ganeti/HTools/Graph.hs \
649         test/hs/Test/Ganeti/HTools/Instance.hs \
650         test/hs/Test/Ganeti/HTools/Loader.hs \
651         test/hs/Test/Ganeti/HTools/Node.hs \
652         test/hs/Test/Ganeti/HTools/PeerMap.hs \
653         test/hs/Test/Ganeti/HTools/Types.hs \
654         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
655         test/hs/Test/Ganeti/JSON.hs \
656         test/hs/Test/Ganeti/Jobs.hs \
657         test/hs/Test/Ganeti/JQueue.hs \
658         test/hs/Test/Ganeti/Luxi.hs \
659         test/hs/Test/Ganeti/Network.hs \
660         test/hs/Test/Ganeti/Objects.hs \
661         test/hs/Test/Ganeti/OpCodes.hs \
662         test/hs/Test/Ganeti/Query/Filter.hs \
663         test/hs/Test/Ganeti/Query/Language.hs \
664         test/hs/Test/Ganeti/Query/Network.hs \
665         test/hs/Test/Ganeti/Query/Query.hs \
666         test/hs/Test/Ganeti/Rpc.hs \
667         test/hs/Test/Ganeti/Runtime.hs \
668         test/hs/Test/Ganeti/Ssconf.hs \
669         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
670         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
671         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
672         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
673         test/hs/Test/Ganeti/THH.hs \
674         test/hs/Test/Ganeti/TestCommon.hs \
675         test/hs/Test/Ganeti/TestHTools.hs \
676         test/hs/Test/Ganeti/TestHelper.hs \
677         test/hs/Test/Ganeti/Types.hs \
678         test/hs/Test/Ganeti/Utils.hs
679
680 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
681
682 HS_BUILT_SRCS = \
683         test/hs/Test/Ganeti/TestImports.hs \
684         src/Ganeti/Constants.hs \
685         src/Ganeti/Curl/Internal.hs \
686         src/Ganeti/Version.hs
687 HS_BUILT_SRCS_IN = \
688         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
689         src/Ganeti/Curl/Internal.hsc
690
691 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
692
693 $(RUN_IN_TEMPDIR): | stamp-directories
694
695 doc/html/index.html: ENABLE_MANPAGES =
696 doc/man-html/index.html: ENABLE_MANPAGES = 1
697 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
698
699 # Note: we use here an order-only prerequisite, as the contents of
700 # _autoconf.py are not actually influencing the html build output: it
701 # has to exist in order for the sphinx module to be loaded
702 # successfully, but we certainly don't want the docs to be rebuilt if
703 # it changes
704 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
705         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
706         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
707         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
708         | $(BUILT_PYTHON_SOURCES)
709         @test -n "$(SPHINX)" || \
710             { echo 'sphinx-build' not found during configure; exit 1; }
711 if !MANPAGES_IN_DOC
712         if test -n '$(ENABLE_MANPAGES)'; then \
713           echo 'Man pages in documentation were disabled at configure time' >&2; \
714           exit 1; \
715         fi
716 endif
717 ## Sphinx provides little control over what content should be included. Some
718 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
719 ## build two different versions of the documentation--once without man pages and
720 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
721 ## us with this, but requires running in a temporary directory. It moves the
722 ## correct files into place depending on environment variables.
723         dir=$(dir $@) && \
724         @mkdir_p@ $$dir && \
725         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
726         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
727             -d . \
728             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
729             -D release="$(PACKAGE_VERSION)" \
730             -D graphviz_dot="$(DOT)" \
731             -D enable_manpages="$(ENABLE_MANPAGES)" \
732             doc $(CURDIR)/$$dir && \
733         rm -f $$dir/.buildinfo $$dir/objects.inv
734         touch $@
735
736 doc/html: doc/html/index.html
737
738 doc/man-html: doc/man-html/index.html
739
740 doc/install-quick.rst: INSTALL
741 doc/news.rst: NEWS
742 doc/upgrade.rst: UPGRADE
743
744 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
745         set -e; \
746         { echo '.. This file is automatically updated at build time from $<.'; \
747           echo '.. Do not edit.'; \
748           echo; \
749           cat $<; \
750         } > $@
751
752 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
753         { echo '.. This file is automatically generated, do not edit!'; \
754           echo ''; \
755           echo 'Man pages'; \
756           echo '========='; \
757           echo; \
758           echo '.. toctree::'; \
759           echo '   :maxdepth: 1'; \
760           echo; \
761           for i in $(notdir $(mandocrst)); do \
762             echo "   $$i"; \
763           done | LC_ALL=C sort; \
764         } > $@
765
766 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
767 if MANPAGES_IN_DOC
768         { echo '.. This file is automatically updated at build time from $<.'; \
769           echo '.. Do not edit.'; \
770           echo; \
771           echo "$*"; \
772           echo '=========================================='; \
773           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
774         } > $@
775 else
776         echo 'Man pages in documentation were disabled at configure time' >&2; \
777         exit 1;
778 endif
779
780 # Things to build but not to install (add it to EXTRA_DIST if it should be
781 # distributed)
782 noinst_DATA = \
783         doc/html \
784         $(BUILT_EXAMPLES) \
785         doc/examples/bash_completion \
786         doc/examples/bash_completion-debug \
787         $(manhtml)
788
789 if MANPAGES_IN_DOC
790 noinst_DATA += doc/man-html
791 endif
792
793 gnt_scripts = \
794         scripts/gnt-backup \
795         scripts/gnt-cluster \
796         scripts/gnt-debug \
797         scripts/gnt-group \
798         scripts/gnt-instance \
799         scripts/gnt-job \
800         scripts/gnt-network \
801         scripts/gnt-node \
802         scripts/gnt-os \
803         scripts/gnt-storage
804
805 PYTHON_BOOTSTRAP_SBIN = \
806         daemons/ganeti-masterd \
807         daemons/ganeti-noded \
808         daemons/ganeti-rapi \
809         daemons/ganeti-watcher \
810         $(gnt_scripts)
811
812 PYTHON_BOOTSTRAP = \
813         $(PYTHON_BOOTSTRAP_SBIN) \
814         tools/burnin \
815         tools/ensure-dirs \
816         tools/node-cleanup \
817         tools/node-daemon-setup \
818         tools/prepare-node-join
819
820 qa_scripts = \
821         qa/__init__.py \
822         qa/ganeti-qa.py \
823         qa/qa_cluster.py \
824         qa/qa_config.py \
825         qa/qa_daemon.py \
826         qa/qa_env.py \
827         qa/qa_error.py \
828         qa/qa_group.py \
829         qa/qa_instance.py \
830         qa/qa_instance_utils.py \
831         qa/qa_job.py \
832         qa/qa_monitoring.py \
833         qa/qa_node.py \
834         qa/qa_os.py \
835         qa/qa_rapi.py \
836         qa/qa_tags.py \
837         qa/qa_utils.py
838
839 bin_SCRIPTS =
840 if WANT_HTOOLS
841 bin_SCRIPTS += $(HS_BIN_PROGS)
842 install-exec-hook:
843         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
844 # FIXME: this is a hardcoded logic, instead of auto-resolving
845         $(LN_S) -f ../../../bin/htools \
846           $(DESTDIR)$(iallocatorsdir)/hail
847         for role in $(HS_BIN_ROLES); do \
848           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
849         done
850 endif
851
852 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
853         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
854           echo "Error: cannot run unittests without the development" \
855                " libraries (see devnotes.rst)" 1>&2; \
856           exit 1; \
857         fi
858         @rm -f $(notdir $@).tix
859         $(GHC) --make \
860           $(HFLAGS) \
861           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
862           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
863           $(HEXTRA) $(HEXTRA_INT) $@
864         @touch "$@"
865
866 # for the test/hs/htest binary, we need to enable profiling/coverage
867 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
868
869 # we compile the hpc-htools binary with the program coverage
870 test/hs/hpc-htools: HEXTRA_INT=-fhpc
871
872 # we compile the hpc-mon-collector binary with the program coverage
873 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
874
875 # test dependency
876 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
877
878 # rules for building profiling-enabled versions of the haskell
879 # programs: hs-prof does the full two-step build, whereas
880 # hs-prof-quick does only the final rebuild (hs-prof must have been
881 # run before)
882 .PHONY: hs-prof hs-prof-quick
883 hs-prof:
884         @if [ -z "$(TARGET)" ]; then \
885           echo "You need to define TARGET when running this rule" 1>&2; \
886           exit 1; \
887         fi
888         $(MAKE) $(AM_MAKEFLAGS) clean
889         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
890         rm -f $(HS_ALL_PROGS)
891         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
892
893 hs-prof-quick:
894         @if [ -z "$(TARGET)" ]; then \
895           echo "You need to define TARGET when running this rule" 1>&2; \
896           exit 1; \
897         fi
898         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
899
900 dist_sbin_SCRIPTS = \
901         tools/ganeti-listrunner
902
903 nodist_sbin_SCRIPTS = \
904         $(PYTHON_BOOTSTRAP_SBIN) \
905         daemons/ganeti-cleaner
906
907 if ENABLE_CONFD
908 src/ganeti-confd: src/hconfd
909         cp -f $< $@
910
911 src/ganeti-luxid: src/hluxid
912         cp -f $< $@
913
914 nodist_sbin_SCRIPTS += src/ganeti-confd
915 nodist_sbin_SCRIPTS += src/ganeti-luxid
916 endif
917
918 if ENABLE_MOND
919 nodist_sbin_SCRIPTS += src/ganeti-mond
920 endif
921
922 python_scripts = \
923         tools/cfgshell \
924         tools/cfgupgrade \
925         tools/cfgupgrade12 \
926         tools/cluster-merge \
927         tools/confd-client \
928         tools/fmtjson \
929         tools/lvmstrap \
930         tools/move-instance \
931         tools/ovfconverter \
932         tools/sanitize-config
933
934 dist_tools_SCRIPTS = \
935         $(python_scripts) \
936         tools/burnin \
937         tools/kvm-console-wrapper \
938         tools/master-ip-setup \
939         tools/xen-console-wrapper
940
941 nodist_tools_python_scripts = \
942         tools/node-cleanup
943
944 nodist_tools_SCRIPTS = \
945         $(nodist_tools_python_scripts) \
946         tools/users-setup \
947         tools/vcluster-setup
948
949 pkglib_python_scripts = \
950         daemons/import-export \
951         tools/check-cert-expired
952
953 nodist_pkglib_python_scripts = \
954         tools/ensure-dirs \
955         tools/node-daemon-setup \
956         tools/prepare-node-join
957
958 myexeclib_SCRIPTS = \
959         daemons/daemon-util \
960         tools/kvm-ifup \
961         tools/vif-ganeti \
962         tools/net-common \
963         $(pkglib_python_scripts) \
964         $(HS_MYEXECLIB_PROGS)
965
966 nodist_myexeclib_SCRIPTS = \
967         $(nodist_pkglib_python_scripts)
968
969 EXTRA_DIST = \
970         NEWS \
971         UPGRADE \
972         epydoc.conf.in \
973         pylintrc \
974         autotools/build-bash-completion \
975         autotools/build-rpc \
976         autotools/check-header \
977         autotools/check-imports \
978         autotools/check-man-dashes \
979         autotools/check-man-references \
980         autotools/check-man-warnings \
981         autotools/check-news \
982         autotools/check-python-code \
983         autotools/check-tar \
984         autotools/check-version \
985         autotools/convert-constants \
986         autotools/docpp \
987         autotools/gen-py-coverage \
988         autotools/sphinx-wrapper \
989         autotools/testrunner \
990         autotools/wrong-hardcoded-paths \
991         $(RUN_IN_TEMPDIR) \
992         daemons/daemon-util.in \
993         daemons/ganeti-cleaner.in \
994         $(pkglib_python_scripts) \
995         devel/upload \
996         devel/webserver \
997         tools/kvm-ifup.in \
998         tools/vif-ganeti.in \
999         tools/net-common.in \
1000         tools/users-setup.in \
1001         tools/vcluster-setup.in \
1002         $(docinput) \
1003         doc/html \
1004         $(BUILT_EXAMPLES:%=%.in) \
1005         doc/examples/ganeti.default \
1006         doc/examples/ganeti.default-debug \
1007         doc/examples/hooks/ethers \
1008         doc/examples/gnt-debug/README \
1009         doc/examples/gnt-debug/delay0.json \
1010         doc/examples/gnt-debug/delay50.json \
1011         test/py/lockperf.py \
1012         test/py/testutils.py \
1013         test/py/mocks.py \
1014         $(dist_TESTS) \
1015         $(TEST_FILES) \
1016         man/footer.rst \
1017         $(manrst) \
1018         $(maninput) \
1019         qa/qa-sample.json \
1020         $(qa_scripts) \
1021         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1022         $(HS_PROG_SRCS) \
1023         src/lint-hints.hs \
1024         test/hs/cli-tests-defs.sh \
1025         test/hs/offline-test.sh \
1026         .ghci
1027
1028 man_MANS = \
1029         man/ganeti-cleaner.8 \
1030         man/ganeti-confd.8 \
1031         man/ganeti-luxid.8 \
1032         man/ganeti-listrunner.8 \
1033         man/ganeti-masterd.8 \
1034         man/ganeti-mond.8 \
1035         man/ganeti-noded.8 \
1036         man/ganeti-os-interface.7 \
1037         man/ganeti-extstorage-interface.7 \
1038         man/ganeti-rapi.8 \
1039         man/ganeti-watcher.8 \
1040         man/ganeti.7 \
1041         man/gnt-backup.8 \
1042         man/gnt-cluster.8 \
1043         man/gnt-debug.8 \
1044         man/gnt-group.8 \
1045         man/gnt-network.8 \
1046         man/gnt-instance.8 \
1047         man/gnt-job.8 \
1048         man/gnt-node.8 \
1049         man/gnt-os.8 \
1050         man/gnt-storage.8 \
1051         man/hail.1 \
1052         man/harep.1 \
1053         man/hbal.1 \
1054         man/hcheck.1 \
1055         man/hinfo.1 \
1056         man/hscan.1 \
1057         man/hspace.1 \
1058         man/hroller.1 \
1059         man/htools.1 \
1060         man/mon-collector.7
1061
1062 # Remove extensions from all filenames in man_MANS
1063 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1064
1065 manrst = $(patsubst %,%.rst,$(mannoext))
1066 manhtml = $(patsubst %.rst,%.html,$(manrst))
1067 mangen = $(patsubst %.rst,%.gen,$(manrst))
1068 maninput = \
1069         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1070         $(patsubst %.html,%.html.in,$(manhtml)) \
1071         $(mangen)
1072
1073 TEST_FILES = \
1074         test/autotools/autotools-check-news.test \
1075         test/data/htools/clean-nonzero-score.data \
1076         test/data/htools/common-suffix.data \
1077         test/data/htools/empty-cluster.data \
1078         test/data/htools/hail-alloc-drbd.json \
1079         test/data/htools/hail-alloc-invalid-network.json \
1080         test/data/htools/hail-alloc-invalid-twodisks.json \
1081         test/data/htools/hail-alloc-restricted-network.json \
1082         test/data/htools/hail-alloc-spindles.json \
1083         test/data/htools/hail-alloc-twodisks.json \
1084         test/data/htools/hail-change-group.json \
1085         test/data/htools/hail-invalid-reloc.json \
1086         test/data/htools/hail-node-evac.json \
1087         test/data/htools/hail-reloc-drbd.json \
1088         test/data/htools/hbal-excl-tags.data \
1089         test/data/htools/hbal-split-insts.data \
1090         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1091         test/data/htools/hspace-tiered-dualspec.data \
1092         test/data/htools/hspace-tiered-exclusive.data \
1093         test/data/htools/hspace-tiered-ipolicy.data \
1094         test/data/htools/hspace-tiered-mixed.data \
1095         test/data/htools/hspace-tiered-resourcetypes.data \
1096         test/data/htools/hspace-tiered-vcpu.data \
1097         test/data/htools/hspace-tiered.data \
1098         test/data/htools/invalid-node.data \
1099         test/data/htools/missing-resources.data \
1100         test/data/htools/multiple-master.data \
1101         test/data/htools/multiple-tags.data \
1102         test/data/htools/n1-failure.data \
1103         test/data/htools/rapi/groups.json \
1104         test/data/htools/rapi/info.json \
1105         test/data/htools/rapi/instances.json \
1106         test/data/htools/rapi/nodes.json \
1107         test/data/htools/hroller-full.data \
1108         test/data/htools/hroller-nodegroups.data \
1109         test/data/htools/hroller-nonredundant.data \
1110         test/data/htools/hroller-online.data \
1111         test/data/htools/unique-reboot-order.data \
1112         test/hs/shelltests/htools-balancing.test \
1113         test/hs/shelltests/htools-basic.test \
1114         test/hs/shelltests/htools-dynutil.test \
1115         test/hs/shelltests/htools-excl.test \
1116         test/hs/shelltests/htools-hail.test \
1117         test/hs/shelltests/htools-hroller.test \
1118         test/hs/shelltests/htools-hspace.test \
1119         test/hs/shelltests/htools-invalid.test \
1120         test/hs/shelltests/htools-multi-group.test \
1121         test/hs/shelltests/htools-no-backend.test \
1122         test/hs/shelltests/htools-rapi.test \
1123         test/hs/shelltests/htools-single-group.test \
1124         test/hs/shelltests/htools-text-backend.test \
1125         test/hs/shelltests/htools-mon-collector.test \
1126         test/data/bdev-drbd-8.0.txt \
1127         test/data/bdev-drbd-8.3.txt \
1128         test/data/bdev-drbd-8.4.txt \
1129         test/data/bdev-drbd-8.4-no-disk-params.txt \
1130         test/data/bdev-drbd-disk.txt \
1131         test/data/bdev-drbd-net-ip4.txt \
1132         test/data/bdev-drbd-net-ip6.txt \
1133         test/data/bdev-rbd/json_output_empty.txt \
1134         test/data/bdev-rbd/json_output_extra_matches.txt \
1135         test/data/bdev-rbd/json_output_no_matches.txt \
1136         test/data/bdev-rbd/json_output_ok.txt \
1137         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1138         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1139         test/data/bdev-rbd/plain_output_new_ok.txt \
1140         test/data/bdev-rbd/plain_output_old_empty.txt \
1141         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1142         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1143         test/data/bdev-rbd/plain_output_old_ok.txt \
1144         test/data/bdev-rbd/output_invalid.txt \
1145         test/data/cert1.pem \
1146         test/data/cert2.pem \
1147         test/data/cluster_config_2.7.json \
1148         test/data/cluster_config_2.8.json \
1149         test/data/instance-minor-pairing.txt \
1150         test/data/instance-prim-sec.txt \
1151         test/data/ip-addr-show-dummy0.txt \
1152         test/data/ip-addr-show-lo-ipv4.txt \
1153         test/data/ip-addr-show-lo-ipv6.txt \
1154         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1155         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1156         test/data/ip-addr-show-lo-oneline.txt \
1157         test/data/ip-addr-show-lo.txt \
1158         test/data/kvm_0.12.5_help.txt \
1159         test/data/kvm_0.15.90_help.txt \
1160         test/data/kvm_0.9.1_help.txt \
1161         test/data/kvm_0.9.1_help_boot_test.txt \
1162         test/data/kvm_1.0_help.txt \
1163         test/data/kvm_1.1.2_help.txt \
1164         test/data/lvs_lv.txt \
1165         test/data/NEWS_OK.txt \
1166         test/data/NEWS_previous_unreleased.txt \
1167         test/data/ovfdata/compr_disk.vmdk.gz \
1168         test/data/ovfdata/config.ini \
1169         test/data/ovfdata/corrupted_resources.ovf \
1170         test/data/ovfdata/empty.ini \
1171         test/data/ovfdata/empty.ovf \
1172         test/data/ovfdata/ganeti.mf \
1173         test/data/ovfdata/ganeti.ovf \
1174         test/data/ovfdata/gzip_disk.ovf \
1175         test/data/ovfdata/new_disk.vmdk \
1176         test/data/ovfdata/no_disk.ini \
1177         test/data/ovfdata/no_disk_in_ref.ovf \
1178         test/data/ovfdata/no_os.ini \
1179         test/data/ovfdata/no_ovf.ova \
1180         test/data/ovfdata/other/rawdisk.raw \
1181         test/data/ovfdata/ova.ova \
1182         test/data/ovfdata/rawdisk.raw \
1183         test/data/ovfdata/second_disk.vmdk \
1184         test/data/ovfdata/unsafe_path.ini \
1185         test/data/ovfdata/virtualbox.ovf \
1186         test/data/ovfdata/wrong_config.ini \
1187         test/data/ovfdata/wrong_extension.ovd \
1188         test/data/ovfdata/wrong_manifest.mf \
1189         test/data/ovfdata/wrong_manifest.ovf \
1190         test/data/ovfdata/wrong_ova.ova \
1191         test/data/ovfdata/wrong_xml.ovf \
1192         test/data/proc_diskstats.txt \
1193         test/data/proc_drbd8.txt \
1194         test/data/proc_drbd80-emptyline.txt \
1195         test/data/proc_drbd80-emptyversion.txt \
1196         test/data/proc_drbd83.txt \
1197         test/data/proc_drbd83_sync.txt \
1198         test/data/proc_drbd83_sync_want.txt \
1199         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1200         test/data/proc_drbd84.txt \
1201         test/data/proc_drbd84_sync.txt \
1202         test/data/qa-minimal-nodes-instances-only.json \
1203         test/data/sys_drbd_usermode_helper.txt \
1204         test/data/vgreduce-removemissing-2.02.02.txt \
1205         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1206         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1207         test/data/vgs-missing-pvs-2.02.02.txt \
1208         test/data/vgs-missing-pvs-2.02.66.txt \
1209         test/data/xen-xm-info-4.0.1.txt \
1210         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1211         test/data/xen-xm-list-4.0.1-four-instances.txt \
1212         test/data/xen-xm-list-long-4.0.1.txt \
1213         test/data/xen-xm-uptime-4.0.1.txt \
1214         test/py/ganeti-cli.test \
1215         test/py/gnt-cli.test \
1216         test/py/import-export_unittest-helper
1217
1218
1219 python_tests = \
1220         doc/examples/rapi_testutils.py \
1221         test/py/cfgupgrade_unittest.py \
1222         test/py/docs_unittest.py \
1223         test/py/ganeti.asyncnotifier_unittest.py \
1224         test/py/ganeti.backend_unittest-runasroot.py \
1225         test/py/ganeti.backend_unittest.py \
1226         test/py/ganeti.bootstrap_unittest.py \
1227         test/py/ganeti.cli_unittest.py \
1228         test/py/ganeti.client.gnt_cluster_unittest.py \
1229         test/py/ganeti.client.gnt_instance_unittest.py \
1230         test/py/ganeti.client.gnt_job_unittest.py \
1231         test/py/ganeti.cmdlib_unittest.py \
1232         test/py/ganeti.cmdlib.cluster_unittest.py \
1233         test/py/ganeti.cmdlib.instance_storage_unittest.py \
1234         test/py/ganeti.compat_unittest.py \
1235         test/py/ganeti.confd.client_unittest.py \
1236         test/py/ganeti.config_unittest.py \
1237         test/py/ganeti.constants_unittest.py \
1238         test/py/ganeti.daemon_unittest.py \
1239         test/py/ganeti.errors_unittest.py \
1240         test/py/ganeti.hooks_unittest.py \
1241         test/py/ganeti.ht_unittest.py \
1242         test/py/ganeti.http_unittest.py \
1243         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1244         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1245         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1246         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1247         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1248         test/py/ganeti.hypervisor_unittest.py \
1249         test/py/ganeti.impexpd_unittest.py \
1250         test/py/ganeti.jqueue_unittest.py \
1251         test/py/ganeti.jstore_unittest.py \
1252         test/py/ganeti.locking_unittest.py \
1253         test/py/ganeti.luxi_unittest.py \
1254         test/py/ganeti.masterd.iallocator_unittest.py \
1255         test/py/ganeti.masterd.instance_unittest.py \
1256         test/py/ganeti.mcpu_unittest.py \
1257         test/py/ganeti.netutils_unittest.py \
1258         test/py/ganeti.objects_unittest.py \
1259         test/py/ganeti.opcodes_unittest.py \
1260         test/py/ganeti.outils_unittest.py \
1261         test/py/ganeti.ovf_unittest.py \
1262         test/py/ganeti.qlang_unittest.py \
1263         test/py/ganeti.query_unittest.py \
1264         test/py/ganeti.rapi.baserlib_unittest.py \
1265         test/py/ganeti.rapi.client_unittest.py \
1266         test/py/ganeti.rapi.resources_unittest.py \
1267         test/py/ganeti.rapi.rlib2_unittest.py \
1268         test/py/ganeti.rapi.testutils_unittest.py \
1269         test/py/ganeti.rpc_unittest.py \
1270         test/py/ganeti.runtime_unittest.py \
1271         test/py/ganeti.serializer_unittest.py \
1272         test/py/ganeti.server.rapi_unittest.py \
1273         test/py/ganeti.ssconf_unittest.py \
1274         test/py/ganeti.ssh_unittest.py \
1275         test/py/ganeti.storage.bdev_unittest.py \
1276         test/py/ganeti.storage.container_unittest.py \
1277         test/py/ganeti.storage.drbd_unittest.py \
1278         test/py/ganeti.storage.filestorage_unittest.py \
1279         test/py/ganeti.tools.burnin_unittest.py \
1280         test/py/ganeti.tools.ensure_dirs_unittest.py \
1281         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1282         test/py/ganeti.tools.prepare_node_join_unittest.py \
1283         test/py/ganeti.uidpool_unittest.py \
1284         test/py/ganeti.utils.algo_unittest.py \
1285         test/py/ganeti.utils.filelock_unittest.py \
1286         test/py/ganeti.utils.hash_unittest.py \
1287         test/py/ganeti.utils.io_unittest-runasroot.py \
1288         test/py/ganeti.utils.io_unittest.py \
1289         test/py/ganeti.utils.log_unittest.py \
1290         test/py/ganeti.utils.lvm_unittest.py \
1291         test/py/ganeti.utils.mlock_unittest.py \
1292         test/py/ganeti.utils.nodesetup_unittest.py \
1293         test/py/ganeti.utils.process_unittest.py \
1294         test/py/ganeti.utils.retry_unittest.py \
1295         test/py/ganeti.utils.storage_unittest.py \
1296         test/py/ganeti.utils.text_unittest.py \
1297         test/py/ganeti.utils.wrapper_unittest.py \
1298         test/py/ganeti.utils.x509_unittest.py \
1299         test/py/ganeti.utils_unittest.py \
1300         test/py/ganeti.vcluster_unittest.py \
1301         test/py/ganeti.workerpool_unittest.py \
1302         test/py/pycurl_reset_unittest.py \
1303         test/py/qa.qa_config_unittest.py \
1304         test/py/tempfile_fork_unittest.py
1305
1306 haskell_tests = test/hs/htest
1307
1308 dist_TESTS = \
1309         test/py/check-cert-expired_unittest.bash \
1310         test/py/daemon-util_unittest.bash \
1311         test/py/ganeti-cleaner_unittest.bash \
1312         test/py/import-export_unittest.bash \
1313         test/py/cli-test.bash \
1314         test/py/bash_completion.bash
1315
1316 if PY_UNIT
1317 dist_TESTS += $(python_tests)
1318 endif
1319
1320 nodist_TESTS =
1321 check_SCRIPTS =
1322
1323 if WANT_HSTESTS
1324 nodist_TESTS += $(haskell_tests)
1325 dist_TESTS += test/hs/offline-test.sh
1326 check_SCRIPTS += \
1327         test/hs/hpc-htools \
1328         test/hs/hpc-mon-collector \
1329         $(HS_BUILT_TEST_HELPERS)
1330 endif
1331
1332 TESTS = $(dist_TESTS) $(nodist_TESTS)
1333
1334 # Environment for all tests
1335 PLAIN_TESTS_ENVIRONMENT = \
1336         PYTHONPATH=. \
1337         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1338         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1339         $(RUN_IN_TEMPDIR)
1340
1341 # Environment for tests run by automake
1342 TESTS_ENVIRONMENT = \
1343         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1344
1345 all_python_code = \
1346         $(dist_sbin_SCRIPTS) \
1347         $(python_scripts) \
1348         $(pkglib_python_scripts) \
1349         $(nodist_pkglib_python_scripts) \
1350         $(nodist_tools_python_scripts) \
1351         $(pkgpython_PYTHON) \
1352         $(client_PYTHON) \
1353         $(cmdlib_PYTHON) \
1354         $(hypervisor_PYTHON) \
1355         $(storage_PYTHON) \
1356         $(rapi_PYTHON) \
1357         $(server_PYTHON) \
1358         $(pytools_PYTHON) \
1359         $(http_PYTHON) \
1360         $(confd_PYTHON) \
1361         $(masterd_PYTHON) \
1362         $(impexpd_PYTHON) \
1363         $(utils_PYTHON) \
1364         $(watcher_PYTHON) \
1365         $(noinst_PYTHON) \
1366         $(qa_scripts)
1367
1368 if PY_UNIT
1369 all_python_code += $(python_tests)
1370 endif
1371
1372 srclink_files = \
1373         man/footer.rst \
1374         test/py/check-cert-expired_unittest.bash \
1375         test/py/daemon-util_unittest.bash \
1376         test/py/ganeti-cleaner_unittest.bash \
1377         test/py/import-export_unittest.bash \
1378         test/py/cli-test.bash \
1379         test/py/bash_completion.bash \
1380         test/hs/offline-test.sh \
1381         test/hs/cli-tests-defs.sh \
1382         $(all_python_code) \
1383         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1384         $(docinput)
1385
1386 check_python_code = \
1387         $(BUILD_BASH_COMPLETION) \
1388         $(CHECK_IMPORTS) \
1389         $(CHECK_HEADER) \
1390         $(DOCPP) \
1391         $(all_python_code)
1392
1393 lint_python_code = \
1394         ganeti \
1395         ganeti/http/server.py \
1396         $(dist_sbin_SCRIPTS) \
1397         $(python_scripts) \
1398         $(pkglib_python_scripts) \
1399         $(BUILD_BASH_COMPLETION) \
1400         $(CHECK_IMPORTS) \
1401         $(CHECK_HEADER) \
1402         $(DOCPP) \
1403         $(PYTHON_BOOTSTRAP)
1404
1405 standalone_python_modules = \
1406         lib/rapi/client.py \
1407         tools/ganeti-listrunner
1408
1409 pep8_python_code = \
1410         ganeti \
1411         ganeti/http/server.py \
1412         $(dist_sbin_SCRIPTS) \
1413         $(python_scripts) \
1414         $(pkglib_python_scripts) \
1415         $(BUILD_BASH_COMPLETION) \
1416         $(CHECK_HEADER) \
1417         $(DOCPP) \
1418         $(PYTHON_BOOTSTRAP) \
1419         qa
1420
1421 test/py/daemon-util_unittest.bash: daemons/daemon-util
1422
1423 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1424
1425 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1426
1427 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1428         sed -f $(REPLACE_VARS_SED) < $< > $@
1429         chmod +x $@
1430
1431 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1432         sed -f $(REPLACE_VARS_SED) < $< > $@
1433         chmod +x $@
1434
1435 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1436         sed -f $(REPLACE_VARS_SED) < $< > $@
1437         chmod +x $@
1438
1439 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1440         sed -f $(REPLACE_VARS_SED) < $< > $@
1441         chmod +x $@
1442
1443 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1444         sed -f $(REPLACE_VARS_SED) < $< > $@
1445         chmod +x $@
1446
1447 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1448         sed -f $(REPLACE_VARS_SED) < $< > $@
1449         chmod +x $@
1450
1451 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1452         sed -f $(REPLACE_VARS_SED) < $< > $@
1453
1454 doc/examples/bash_completion: BC_ARGS = --compact
1455 doc/examples/bash_completion-debug: BC_ARGS =
1456
1457 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1458         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1459         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1460         daemons/ganeti-cleaner \
1461         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1462         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1463           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1464
1465 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1466         lib/build/shell_example_lexer.py \
1467         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1468         @echo "Checking $< for hardcoded paths..."
1469         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1470           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1471           exit 1; \
1472         fi
1473         set -e ; \
1474         trap 'echo auto-removing $@; rm $@' EXIT; \
1475         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1476         $(CHECK_MAN_REFERENCES) $@; \
1477         trap - EXIT
1478
1479 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1480         @test -n "$(PANDOC)" || \
1481           { echo 'pandoc' not found during configure; exit 1; }
1482         set -o pipefail -e; \
1483         trap 'echo auto-removing $@; rm $@' EXIT; \
1484         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1485           sed -e 's/\\@/@/g' > $@; \
1486         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1487         $(CHECK_MAN_DASHES) $@; \
1488         trap - EXIT
1489
1490 man/%.html.in: man/%.gen man/footer.rst
1491         @test -n "$(PANDOC)" || \
1492           { echo 'pandoc' not found during configure; exit 1; }
1493         set -o pipefail ; \
1494         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1495           sed -e 's/\\@/@/g' > $@
1496
1497 man/%: man/%.in  $(REPLACE_VARS_SED)
1498         sed -f $(REPLACE_VARS_SED) < $< > $@
1499
1500 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1501         sed -f $(REPLACE_VARS_SED) < $< > $@
1502
1503 vcs-version:
1504         if test -d .git; then \
1505           git describe > $@; \
1506         elif test ! -f $@ ; then \
1507           echo "Cannot auto-generate $@ file"; exit 1; \
1508         fi
1509
1510 .PHONY: clean-vcs-version
1511 clean-vcs-version:
1512         rm -f vcs-version
1513
1514 .PHONY: regen-vcs-version
1515 regen-vcs-version:
1516         @set -e; \
1517         cd $(srcdir); \
1518         if test -d .git; then \
1519           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1520           git describe > $$T; \
1521           if ! cmp --quiet $$T vcs-version; then \
1522             mv $$T vcs-version; \
1523           fi; \
1524         fi
1525
1526 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1527         vcs-version $(built_base_sources)
1528         set -e; \
1529         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1530         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1531
1532 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1533         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1534         lib/jstore.py $(RUN_IN_TEMPDIR) \
1535         $(CONVERT_CONSTANTS) $(built_base_sources) \
1536         | lib/_vcsversion.py
1537         set -e; \
1538         { cat $< ; \
1539           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1540         } > $@
1541
1542 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1543         hsc2hs -o $@ $<
1544
1545 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1546         $(built_base_sources)
1547         set -e; \
1548         { cat $< ; \
1549           echo ; \
1550           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1551             echo "import $$name ()" ; \
1552           done ; \
1553         } > $@
1554
1555 lib/_autoconf.py: Makefile | stamp-directories
1556         set -e; \
1557         { echo '# This file is automatically generated, do not edit!'; \
1558           echo '#'; \
1559           echo ''; \
1560           echo '"""Build-time configuration for Ganeti.'; \
1561           echo '';\
1562           echo 'This file is autogenerated by the build process.'; \
1563           echo 'For any changes you need to re-run ./configure (and'; \
1564           echo 'not edit by hand).'; \
1565           echo ''; \
1566           echo '"""'; \
1567           echo ''; \
1568           echo '# pylint: disable=C0301,C0324'; \
1569           echo '# because this is autogenerated, we do not want'; \
1570           echo '# style warnings' ; \
1571           echo ''; \
1572           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1573           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1574           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1575           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1576           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1577           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1578           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1579           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1580           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1581           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1582           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1583           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1584           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1585           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1586           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1587           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1588           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1589           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1590           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1591           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1592           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1593           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1594           echo "KVM_PATH = '$(KVM_PATH)'"; \
1595           echo "IP_PATH = '$(IP_PATH)'"; \
1596           echo "SOCAT_PATH = '$(SOCAT)'"; \
1597           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1598           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1599           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1600           echo "TOOLSDIR = '$(toolsdir)'"; \
1601           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1602           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1603           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1604           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1605           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1606           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1607           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1608           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1609           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1610           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1611           echo "RAPI_USER = '$(RAPI_USER)'"; \
1612           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1613           echo "CONFD_USER = '$(CONFD_USER)'"; \
1614           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1615           echo "LUXID_USER = '$(LUXID_USER)'"; \
1616           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1617           echo "NODED_USER = '$(NODED_USER)'"; \
1618           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1619           echo "MOND_USER = '$(MOND_USER)'"; \
1620           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1621           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1622           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1623           echo "HTOOLS = True"; \
1624           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1625           echo "XEN_CMD = '$(XEN_CMD)'"; \
1626           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1627           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1628           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1629 ## Write dictionary with man page name as the key and the section number as the
1630 ## value
1631           echo "MAN_PAGES = {"; \
1632           for i in $(notdir $(man_MANS)); do \
1633             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1634           done; \
1635           echo "}"; \
1636         } > $@
1637
1638 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1639         set -e; \
1640         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1641         { echo '# This file is automatically generated, do not edit!'; \
1642           echo '#'; \
1643           echo ''; \
1644           echo '"""Build-time VCS version number for Ganeti.'; \
1645           echo '';\
1646           echo 'This file is autogenerated by the build process.'; \
1647           echo 'For any changes you need to re-run ./configure (and'; \
1648           echo 'not edit by hand).'; \
1649           echo ''; \
1650           echo '"""'; \
1651           echo ''; \
1652           echo '# pylint: disable=C0301,C0324'; \
1653           echo '# because this is autogenerated, we do not want'; \
1654           echo '# style warnings' ; \
1655           echo ''; \
1656           echo "VCS_VERSION = '$$VCSVER'"; \
1657         } > $@
1658
1659 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1660         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1661
1662 $(SHELL_ENV_INIT): Makefile stamp-directories
1663         set -e; \
1664         { echo '# Allow overriding for tests'; \
1665           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1666           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1667           echo; \
1668           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1669           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1670           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1671           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1672           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1673         } > $@
1674
1675 ## Writes sed script to replace placeholders with build-time values. The
1676 ## additional quotes after the first @ sign are necessary to stop configure
1677 ## from replacing those values as well.
1678 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1679         set -e; \
1680         { echo 's#@''PREFIX@#$(prefix)#g'; \
1681           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1682           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1683           echo 's#@''BINDIR@#$(bindir)#g'; \
1684           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1685           echo 's#@''LIBDIR@#$(libdir)#g'; \
1686           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1687           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1688           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1689           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1690           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1691           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1692           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1693           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1694           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1695           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1696           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1697           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1698           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1699           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1700           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1701           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1702           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1703           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1704           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1705           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1706           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1707           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1708           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1709           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1710           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1711           echo; \
1712           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1713           echo '  r $(SHELL_ENV_INIT)'; \
1714           echo '  d'; \
1715           echo '}'; \
1716         } > $@
1717
1718 # Using deferred evaluation
1719 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1720 daemons/ganeti-watcher: MODULE = ganeti.watcher
1721 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1722 tools/burnin: MODULE = ganeti.tools.burnin
1723 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1724 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1725 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1726 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1727 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1728
1729 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1730         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1731         set -e; \
1732         { echo '#!/usr/bin/python'; \
1733           echo '# This file is automatically generated, do not edit!'; \
1734           echo "# Edit $(MODULE) instead."; \
1735           echo; \
1736           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1737           echo; \
1738           echo '# pylint: disable=C0103'; \
1739           echo '# C0103: Invalid name'; \
1740           echo; \
1741           echo 'import sys'; \
1742           echo 'import $(MODULE) as main'; \
1743           echo; \
1744           echo '# Temporarily alias commands until bash completion'; \
1745           echo '# generator is changed'; \
1746           echo 'if hasattr(main, "commands"):'; \
1747           echo '  commands = main.commands # pylint: disable=E1101'; \
1748           echo 'if hasattr(main, "aliases"):'; \
1749           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1750           echo; \
1751           echo 'if __name__ == "__main__":'; \
1752           echo '  sys.exit(main.Main())'; \
1753         } > $@
1754         chmod u+x $@
1755
1756 $(HS_BUILT_TEST_HELPERS): Makefile
1757         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1758         set -e; \
1759         { echo '#!/bin/sh'; \
1760           echo '# This file is automatically generated, do not edit!'; \
1761           echo "# Edit Makefile.am instead."; \
1762           echo; \
1763           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1764         } > $@
1765         chmod u+x $@
1766
1767 stamp-directories: Makefile
1768         $(MAKE) $(AM_MAKEFLAGS) ganeti
1769         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1770         touch $@
1771
1772 # We need to create symlinks because "make distcheck" will not install Python
1773 # files when building.
1774 stamp-srclinks: Makefile | stamp-directories
1775         set -e; \
1776         for i in $(srclink_files); do \
1777           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1778             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1779           fi; \
1780         done
1781         touch $@
1782
1783 .PHONY: ganeti
1784 ganeti:
1785         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1786
1787 .PHONY: check-dirs
1788 check-dirs: $(GENERATED_FILES)
1789         @set -e; \
1790         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1791           error=; \
1792           while read dir; do \
1793             case "$$dir" in \
1794               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1795               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1796             esac; \
1797           done; \
1798           for dir in $(DIRS); do \
1799             if ! test -d "$$dir"; then \
1800               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1801               error=1; \
1802             fi \
1803           done; \
1804           test -z "$$error"; \
1805         }
1806
1807 .PHONY: check-local
1808 check-local: check-dirs $(GENERATED_FILES)
1809         $(CHECK_PYTHON_CODE) $(check_python_code)
1810         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1811         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1812         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1813         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1814         error= ; \
1815         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1816           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1817           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1818             echo "Incorrect version in README, expected $$expver" >&2; \
1819             error=1; \
1820           fi; \
1821           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1822               doc/security.rst; do \
1823             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1824               "Documents Ganeti version $$expver"; then \
1825               echo "Incorrect version in $$file, expected $$expver" >&2; \
1826               error=1; \
1827             fi; \
1828           done; \
1829           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1830             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1831             error=1; \
1832           fi; \
1833           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1834             ".. Last updated for Ganeti $$expver"; then \
1835             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1836             error=1; \
1837           fi; \
1838         fi; \
1839         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1840           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1841             echo "Longest line in $$file is longer than 80 characters" >&2; \
1842             error=1; \
1843           fi; \
1844         done; \
1845         test -z "$$error"
1846
1847 .PHONY: hs-test-%
1848 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1849         @rm -f htest.tix
1850         test/hs/htest -t $*
1851
1852 .PHONY: hs-tests
1853 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1854         @rm -f htest.tix
1855         ./test/hs/htest
1856
1857 .PHONY: hs-shell-%
1858 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
1859             $(HS_BUILT_TEST_HELPERS)
1860         @rm -f hpc-htools.tix hpc-mon-collector.tix
1861         HBINARY="./test/hs/hpc-htools" \
1862         SHELLTESTARGS=$(SHELLTESTARGS) \
1863         ./test/hs/offline-test.sh $*
1864
1865 .PHONY: hs-shell
1866 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1867         @rm -f hpc-htools.tix hpc-mon-collector.tix
1868         HBINARY="./test/hs/hpc-htools" \
1869         SHELLTESTARGS=$(SHELLTESTARGS) \
1870         ./test/hs/offline-test.sh
1871
1872 .PHONY: hs-check
1873 hs-check: hs-tests hs-shell
1874
1875 # E111: indentation is not a multiple of four
1876 # E121: continuation line indentation is not a multiple of four
1877 #       (since our indent level is not 4)
1878 # E125: continuation line does not distinguish itself from next logical line
1879 #       (since our indent level is not 4)
1880 # E127: continuation line over-indented for visual indent
1881 #       (since our indent level is not 4)
1882 # note: do NOT add E128 here; it's a valid style error in most cases!
1883 # I've seen real errors, but also some cases were we indent wrongly
1884 # due to line length; try to rework the cases where it is triggered,
1885 # instead of silencing it
1886 # E261: at least two spaces before inline comment
1887 # E501: line too long (80 characters)
1888 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1889
1890 # For excluding pep8 expects filenames only, not whole paths
1891 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1892
1893 LINT_TARGETS = pylint pylint-qa
1894 if HAS_PEP8
1895 LINT_TARGETS += pep8
1896 endif
1897 if HAS_HLINT
1898 LINT_TARGETS += hlint
1899 endif
1900
1901 .PHONY: lint
1902 lint: $(LINT_TARGETS)
1903
1904 .PHONY: pylint
1905 pylint: $(GENERATED_FILES)
1906         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1907         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1908
1909 .PHONY: pylint-qa
1910 pylint-qa: $(GENERATED_FILES)
1911         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1912         cd $(top_srcdir)/qa && \
1913           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1914           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1915
1916 .PHONY: pep8
1917 pep8: $(GENERATED_FILES)
1918         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1919         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1920           --repeat $(pep8_python_code)
1921
1922 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1923 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1924 .PHONY: hlint
1925 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1926         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1927         @rm -f doc/hs-lint.html
1928         if tty -s; then C="-c"; else C=""; fi; \
1929         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1930           --ignore "Use first" \
1931           --ignore "Use &&&" \
1932           --ignore "Use void" \
1933           --ignore "Reduce duplication" \
1934           --hint src/lint-hints \
1935           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1936         @if [ ! -f doc/hs-lint.html ]; then \
1937           echo "All good" > doc/hs-lint.html; \
1938         fi
1939
1940 # a dist hook rule for updating the vcs-version file; this is
1941 # hardcoded due to where it needs to build the file...
1942 dist-hook:
1943         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1944         rm -f $(top_distdir)/vcs-version
1945         cp -p $(srcdir)/vcs-version $(top_distdir)
1946
1947 # a distcheck hook rule for catching revision control directories
1948 distcheck-hook:
1949         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1950           echo "Found revision control files in final archive." 1>&2; \
1951           exit 1; \
1952         fi
1953         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1954           echo "Found Python byte code in final archive." 1>&2; \
1955           exit 1; \
1956         fi
1957         if find $(top_distdir) -name '*~' | grep .; then \
1958           echo "Found backup files in final archive." 1>&2; \
1959           exit 1; \
1960         fi
1961 # Empty files or directories should not be distributed. They can cause
1962 # unnecessary warnings for packagers. Directories used by automake during
1963 # distcheck must be excluded.
1964         if find $(top_distdir) -empty -and -not \( \
1965             -path $(top_distdir)/_build -or \
1966             -path $(top_distdir)/_inst \) | grep .; then \
1967           echo "Found empty files or directories in final archive." 1>&2; \
1968           exit 1; \
1969         fi
1970         if test -e $(top_distdir)/doc/man-html; then \
1971           echo "Found documentation including man pages in final archive" >&2; \
1972           exit 1; \
1973         fi
1974
1975 # Backwards compatible distcheck-release target
1976 distcheck-release: distcheck
1977
1978 distrebuildcheck: dist
1979         set -e; \
1980         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1981         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1982         cd $$builddir; \
1983         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1984         cd $(distdir); \
1985         ./configure; \
1986         $(MAKE) maintainer-clean; \
1987         cp $(abs_srcdir)/vcs-version .; \
1988         ./configure; \
1989         $(MAKE) $(AM_MAKEFLAGS)
1990
1991 dist-release: dist
1992         set -e; \
1993         for i in $(DIST_ARCHIVES); do \
1994           echo -n "Checking $$i ... "; \
1995           autotools/check-tar < $$i; \
1996           echo OK; \
1997         done
1998
1999 install-exec-local:
2000         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
2001           "$(DESTDIR)${localstatedir}/log/ganeti" \
2002           "$(DESTDIR)${localstatedir}/run/ganeti"
2003
2004 .PHONY: apidoc
2005 if WANT_HSAPIDOC
2006 apidoc: py-apidoc hs-apidoc
2007 else
2008 apidoc: py-apidoc
2009 endif
2010
2011 .PHONY: py-apidoc
2012 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
2013         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
2014         $(RUN_IN_TEMPDIR) epydoc -v \
2015           --conf $(CURDIR)/epydoc.conf \
2016           --output $(CURDIR)/$(APIDOC_PY_DIR)
2017
2018 .PHONY: hs-apidoc
2019 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2020
2021 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2022         @test -n "$(HSCOLOUR)" || \
2023             { echo 'HsColour' not found during configure; exit 1; }
2024         @test -n "$(HADDOCK)" || \
2025             { echo 'haddock' not found during configure; exit 1; }
2026         rm -rf $(APIDOC_HS_DIR)/*
2027         for i in $(ALL_APIDOC_HS_DIRS); do \
2028           @mkdir_p@ $$i; \
2029           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2030         done
2031         set -e ; \
2032         export LC_ALL=en_US.UTF-8; \
2033         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2034         if [ "$(HS_PARALLEL3)" ]; \
2035         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2036         fi; \
2037         if [ "$(HS_REGEX_PCRE)" ]; \
2038         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2039         fi; \
2040         for file in $(HS_LIBTESTBUILT_SRCS); do \
2041           f_nosrc=$${file##src/}; \
2042           f_notst=$${f_nosrc##test/hs/}; \
2043           f_html=$${f_notst%%.hs}.html; \
2044           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2045         done ; \
2046         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2047           -t ganeti -p src/haddock-prologue \
2048           --source-module="%{MODULE/.//}.html" \
2049           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2050           $$OPTGHC \
2051           $(HS_LIBTESTBUILT_SRCS)
2052
2053 .PHONY: TAGS
2054 TAGS: $(GENERATED_FILES)
2055         rm -f TAGS
2056         $(GHC) -e ":etags" -v0 \
2057           $(filter-out -O -Werror,$(HFLAGS)) \
2058           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2059           $(HS_LIBTEST_SRCS)
2060         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2061           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2062           -path './qa/*.py' | \
2063           etags -l python -a -
2064
2065 .PHONY: coverage
2066
2067 COVERAGE_TESTS=
2068 if WANT_HTOOLS
2069 COVERAGE_TESTS += hs-coverage
2070 endif
2071 if PY_UNIT
2072 COVERAGE_TESTS += py-coverage
2073 endif
2074
2075 coverage: $(COVERAGE_TESTS)
2076
2077 .PHONY: py-coverage
2078 py-coverage: $(GENERATED_FILES) $(python_tests)
2079         @test -n "$(PYCOVERAGE)" || \
2080             { echo 'python-coverage' not found during configure; exit 1; }
2081         set -e; \
2082         COVERAGE=$(PYCOVERAGE) \
2083         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2084         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2085         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2086         $(PLAIN_TESTS_ENVIRONMENT) \
2087         $(abs_top_srcdir)/autotools/gen-py-coverage \
2088         $(python_tests)
2089
2090 .PHONY: hs-coverage
2091 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2092         rm -f *.tix
2093         $(MAKE) $(AM_MAKEFLAGS) hs-check
2094         @mkdir_p@ $(COVERAGE_HS_DIR)
2095         hpc sum --union $(HPCEXCL) \
2096           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2097         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2098         hpc report coverage-hs.tix
2099         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2100
2101 # Special "kind-of-QA" target for htools, needs special setup (all
2102 # tools compiled with -fhpc)
2103 .PHONY: live-test
2104 live-test: all
2105         set -e ; \
2106         cd src; \
2107         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2108         rm -f *.tix *.mix; \
2109         ./live-test.sh; \
2110         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2111           --output=live-test.tix ; \
2112         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2113         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2114           --srcdir=.. $(HPCEXCL) ; \
2115         hpc report --srcdir=.. live-test $(HPCEXCL)
2116
2117 commit-check: autotools-check distcheck lint apidoc
2118
2119 autotools-check:
2120         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2121   $(abs_top_srcdir)/test/autotools/*-*.test \
2122   -- --hide-successes
2123
2124 .PHONY: gitignore-check
2125 gitignore-check:
2126         @if [ -n "`git status --short`" ]; then \
2127           echo "Git status is not clean!" 1>&2 ; \
2128           git status --short; \
2129           exit 1; \
2130         fi
2131
2132 # target to rebuild all man pages (both groff and html output)
2133 .PHONY: man
2134 man: $(man_MANS) $(manhtml)
2135
2136 # Target that builds all binaries (including those that are not
2137 # rebuilt except when running the tests)
2138 .PHONY: really-all
2139 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2140
2141 # we don't need the ancient implicit rules:
2142 %: %,v
2143 %: RCS/%,v
2144 %: RCS/%
2145 %: s.%
2146 %: SCCS/s.%
2147
2148 -include ./Makefile.local
2149
2150 # vim: set noet :